<?php

/* The main part here is the function pjgallery_body() that is called from viewAlbum.php to see the thumbnail pages integrated in a standard web page of the site*/

include_once ($_SERVER['DOCUMENT_ROOT']. INSTALLDIR . "/common.inc.php");
/* 
/* global variable declarations */
$offset = -1;          /*offset in the pic_info array of the first thumbnail of the current page*/
$nb_pictures_page = 0; /*nb pictures in the page */
$previous_offset = -1; /*offset for the previous thumbnail page or -1 if no previous page*/
$next_offset = -1;     /*offset for the next thumbnail page or -1 if no next page*/
$temp_tab = array ();
$output = '';

/* function declarations */

/*declare functions for backward and forward links */
function previous_page() {
	global $output;
  if ($GLOBALS['previous_offset']  != -1) {
    $output .= "<a href= \"viewAlbum.php?alb={$GLOBALS['root_album_desc']}&amp;offset={$GLOBALS['previous_offset']}" . "\" >";

    $output.= "{$GLOBALS['lang_previous_page']}</a>\n";
  }
  }

function next_page() {
	global $output;
  if ($GLOBALS['next_offset'] != -1) {
    $output .= "<a id =\"nextThumbnailPage\"  href= \"viewAlbum.php?alb={$GLOBALS['root_album_desc']}&amp;offset={$GLOBALS['next_offset']}" . "\" onclick= \"javascript: return getPrefetched(); \" >";

    $output .= "{$GLOBALS['lang_next_page']}</a>\n";
  }
  }

function pjgallery_head_links(){
  /*Generates link elements start, prev, and next in the head section to ease search engine referencing.*/
  
    $GLOBALS['previous_offset'] = ($GLOBALS['offset'] == 0) ? -1 : ($GLOBALS['offset'] - $GLOBALS['max_thumbnails_page']);
    $GLOBALS['next_offset'] = (($GLOBALS['offset'] + $GLOBALS['max_thumbnails_page']) < $GLOBALS['nb_pictures']) ? ($GLOBALS['offset'] + $GLOBALS['max_thumbnails_page']) : -1;
    
    /* generates navigation head links for search engines, no javascript prefetching here.*/
    $output = "<link rel=\"start\" href=\"viewAlbum.php?alb={$GLOBALS['root_album_desc']}\" />\n";
    if ($GLOBALS['previous_offset'] != -1) {
      $output .= "<link rel=\"prev\" href=\"viewAlbum.php?alb={$GLOBALS['root_album_desc']} &amp;offset={$GLOBALS['previous_offset']}\"  />\n";
    }
  
    if ( $GLOBALS['next_offset'] != -1) {
      $output .= "<link rel=\"next\" href=\"viewAlbum.php?alb={$GLOBALS['root_album_desc']} &amp;offset={$GLOBALS['next_offset']}\" />\n";
    }
    echo $output;
}//pjgallery_head_links

function pjgallery_body() {
  /* generates the body of viewAlbum*/
	 global $output;
   $output .= "<div id=\"PJGalleryAlb\">\n";
	 $output .= "<h1>" . $GLOBALS['lang_title_album'] . "</h1>\n";
  if (!$GLOBALS['thumbnails']) {
    /* there are no thumbnails to be displayed*/
    /* test if java script is enabled on the client, start diaporama*/
    $output .= "<p id =\"links\">";
    $output .= "&nbsp;&nbsp;<a  href=\"viewPicture.php?alb={$GLOBALS['root_album_desc']}\" >{$GLOBALS['lang_gopictures']}</a>";
		$output .= "&nbsp;|&nbsp;<a  id= \"diaplink\" href=\"viewDiaporama.php?alb={$GLOBALS['root_album_desc']} \" >{$GLOBALS['lang_slideshow']}</a>";
    $output .= "</p>\n";
    $output .= "<noscript><div  class=\"error noprint\">{$GLOBALS['err_javascriptenabled']}</div></noscript>";
    echo $output;
		$output = '';
  } else {
    /* set the number of pictures in the page*/
    $GLOBALS['nb_pictures_page'] = (($GLOBALS['offset'] + $GLOBALS['max_thumbnails_page']) <= $GLOBALS['nb_pictures']) ? $GLOBALS['max_thumbnails_page'] : ($GLOBALS['nb_pictures'] - $GLOBALS['offset']);

    /*display header links of the thumbnail page*/
    $output .= "<div id=\"numberthumbnails\">";
    $output .= $GLOBALS['offset'] + 1 . '-' . ($GLOBALS['offset'] + $GLOBALS['nb_pictures_page']) . " {$GLOBALS['lang_of']} " . $GLOBALS['nb_pictures'];
    $output .= "</div>\n";
    $output .= "<div id =\"links\">";
    previous_page ();
    next_page ();
		$output .= "<a id=\"diaplink\" href=\"viewDiaporama.php?alb={$GLOBALS['root_album_desc']}\" >{$GLOBALS['lang_slideshow']}</a>";
    $output .= "</div>\n";
    /* list thumbnails in float CSS*/
    $output .= "<div id=\"thumbnaillist\" >\n";

    echo $output;

    for ($j = $GLOBALS['offset']; ($j != ($GLOBALS['nb_pictures_page'] + $GLOBALS['offset'])); $j++) {
			$output = '';
      $output .= "<div class=\"thumbnail\">\n";
			if ($GLOBALS['pic_info'][$j][0][0] =='/'){
				$root_img_name = $GLOBALS['lang_nothumbnail'];//inexistent file
				$alt_image = $GLOBALS['lang_nothumbnail'];
			}
				
			else{
				$root_img_name = $GLOBALS['root_album_dir']. "/thumbnails/" . $GLOBALS['pic_info'][$j][0];
				$alt_image = $GLOBALS['pic_info'][$j][1];
				if (!file_exists(abs_name($root_img_name)))
					$alt_image = $GLOBALS['lang_nothumbnail'];
			}
			
			$output .= "<a href=\"viewPicture.php?alb={$GLOBALS['root_album_desc']}&amp;picture={$j}\"" .  "title= \"{$GLOBALS['lang_hover_thumb']}\" >";

			$output .= "<img src=\"{$root_img_name}\" title=\"{$GLOBALS['lang_hover_thumb']}\" alt=\"{$alt_image}\"/>";

      $output .= "</a>\n";
			$name_without_suffix = strip_suffix (basename($GLOBALS['pic_info'][$j][0]));
      $output .= "<p>{$name_without_suffix}</p>\n";
			$output .= "</div>\n";
			echo $output;
    } /*for*/
		echo "</div>\n";
  } /*if */
  $output = "<div class=\"clearfix\"></div>\n";

  $output .= "<div id=\"version\"> <a href=\"http://materialsandresources.freehostia.com/pjgallery/docs/en.PJGallery-free-php-script.htm\">{$GLOBALS['version']}</a></div>\n";

  /* create a hidden  iframe for prefetching thumbnails*/
  $output .= "<iframe src=\"about:blank\" width=\"0\" height=\"0\" frameborder=\"0\" name =\"frameprefetch\" id =\"frameprefetch\"></iframe>";
	$output .= "</div>"; /*end of div PJGalleryAlb*/
	/* create a hidden  iframe for prefetching diaporama, outside PJGalleryAlb so that hopefully, it's just loaded once when the first  album page is loaded*/
	$output .= "<iframe src=\"about:blank\" width=\"0\" height=\"0\" frameborder=\"0\" name =\"frameprefetchdiap\" id =\"frameprefetchdiap\"></iframe>";
	echo $output;
  }
/* *************************************
*  ENTRY POINT
****************************************/
    /* check offset, cast as int as a way to filter input*/
    $offset = (isset($_GET['offset'])) ? (int)$_GET['offset'] : 0;
    
    if (($offset + 1) > $nb_pictures)
    die ($err_msg);
    
    if (($offset % $GLOBALS['max_thumbnails_page']) != 0)
    $offset = ((int)($offset / $GLOBALS['max_thumbnails_page']) * $GLOBALS['max_thumbnails_page']);
    
    /* check that the three pages viewAlbum, viewDiaporama, and viewPicture are in the same directory*/
    $dir_view = dirname(str_replace('\\', '/', $GLOBALS['call_FILE']));
    if (!file_exists ($dir_view . "/viewDiaporama.php") || !file_exists ($dir_view . "/viewPicture.php"))
    die("viewAlbum.php, viewDiaporama.php, viewPicture.php must be in the same directory");



/* *************************************
*  OBSOLETE CODE
****************************************/
/* 
function load_exif_data(){
//Adapt to your needs, here the whole set of exif data is appended to the image caption
			if (extension_loaded('exif') && $GLOBALS['extract_exif']){
					for ($i=0; ($i!=count($_SESSION['pic_info'])); $i++){
					$exif_comments = array();
					if ($exif_comments = exif_read_data("{$_SESSION['directory']}" . DIRECTORY_SEPARATOR . $GLOBALS['dir_images']. DIRECTORY_SEPARATOR . "{$_SESSION['pic_info'][$i][0]}", 0, true)){
							$_SESSION['pic_info'][$i][1] .= '<br />' ;
							foreach ($exif_comments as $key => $section) {
   							 foreach ($section as $name => $val) {
									$_SESSION['pic_info'][$i][1] .= '&nbsp;'.$val;
								}
							}
							$_SESSION['pic_info'][$i][1] = substr($_SESSION['pic_info'][$i][1],0,strlen($_SESSION['pic_info'][$i][1]) - 2);//remove the end character
					}
 					}
 			}		
}//end load_exif_data
*/
?>
