<?php 
/*This software is governed by a creative commons license whose terms of use are explained in the readme file */

/* set the constant INSTALLDIR to the root-based directory name where pjgallery is installed.*/

/*This file can be moved where you wish within your site to accomodate the resolution of your relative links if any, but then you should move both viewPicture.php and viewDiaporama.php as well. */

/*Complete the head section if necessary. Here, the title and the meta clauses  are set to the values found in the album description file (or the default album description if they are generic (not overridden)) concatenated with the offset value of the first picture of the thumbnail page. Add your css and javascript if any.*/

/*complete the body section if necessary but don't set the onload attribute of the body tag. If you need to execute onload handlers  use the addOnLoadHandler function, and call it before the call to prefetchNextPage in the head section since the handlers will be executed in the same order that they are listed. PrefetchNextPage() is just a performance accelerator and should be executed last.*/

/*If you're adding php code, make sure your global variables (if any) don't interfere with those of PJGallery declared in initAlbum.inc.php, common.inc.php, and the default album options. The same applies for php function names. Also, your javascript declarations, if any, should have identifiers different to those declared in pjgallery.js since they are merged into the same name space.*/

define ('INSTALLDIR', '/pjgallery');

/* don't modify the following lines*/

$call_FILE = __FILE__;
include_once($_SERVER['DOCUMENT_ROOT']. INSTALLDIR . "/initAlbum.inc.php");
?>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="<?php echo $lang;?>" lang="<?php echo $lang; ?>">

<head>

<!--complete the head section if necessary-->
<meta name="viewport" content="width=device-width, initial-scale=1">

<title><?php echo $lang_title_album . ' - offset: ' . $offset ;?></title>
<meta http-equiv="content-type" content="text/html; charset=<?php echo $charset ?>" />
<meta http-equiv ="content-script-type" content = "text/javascript" />
<meta name = "robots" content = "<?php echo $index_thumbnails; ?>" />

<!--generate start, prev, and next links for search engines-->
<?php pjgallery_head_links();?>

<meta name="description" content="<?php echo   $meta_description . ' - offset: ' . $offset ?>" />

<link href= "<?php echo $root_css; ?>" rel= "stylesheet" type="text/css" media ="all" />

<script type="text/javascript" src="<?php echo INSTALLDIR. "/pjgallery.js"; ?>"></script>
<script>
//!CDATA[
/* add your own addOnLoadHandler(MyHandler) if any here */
addOnLoadHandler(prefetchNextPage);
//]]
</script>

</head>


<body id="<?php echo $body_id ?>">

<!--complete the body section if necessary-->
<?php pjgallery_body();?>

</body>

</html>


