<?php 
/*This software is governed by a creative commons license whose terms of use are explained in the readme file */
/* set INSTALLDIR to the installation directory*/
define ('INSTALLDIR', '/pjgallery');
/* set $view_album to the relative  path (w.r.t. this file) of the viewAlbum.php page */
$view_album = "viewAlbum.php";
$call_FILE = __FILE__;
include_once ($_SERVER['DOCUMENT_ROOT']. INSTALLDIR . "/common.inc.php");
?>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="<?php echo $lang;?>" lang="<?php echo $lang; ?>">

<head>
<meta http-equiv="content-type" content="text/html; charset=<?php echo $charset ?>" />
<meta name="viewport" content="width=device-width, initial-scale=1">
<title><?php echo $lang_title_album;?></title>
<meta name = "robots" content = "noindex, nofollow" />
<meta http-equiv ="content-script-type" content = "text/javascript" />
<link href= "<?php echo $root_css; ?>" rel= "stylesheet" type="text/css" media ="all" />
<link href= "<?php echo $root_css_print; ?>" rel= "stylesheet" type="text/css" media ="print" />
<script type="text/javascript" src="<?php echo INSTALLDIR. "/pjgallery.js"; ?>"></script>
<script language="JavaScript" type="text/javascript">
//!CDATA[
   //variable declarations
onerror= function(msg, url, line){alert("error: "+ msg +"\n"+url +":"+line);return false;}

   var dirAlbumImages = "<?php echo $root_album_dir . '/' . 'images' . '/' ?>";
   var delay = <?php echo $GLOBALS['delay'] ?>;
   var step = <?php echo $GLOBALS['step'] ?>;
   var pause = <?php echo $GLOBALS['pause'] ?>;
   var nbPictures = <?php echo $nb_pictures; ?>;
   var nextPicture;
   var prevPicture;
	 var startPicture;
	 var currentPicture;
	 var round;
   var slide; // slide on : a slide show is active
   var timer = null;
   var langOf = '<?php echo $GLOBALS['lang_of'];?>';
   var langStartSlide = '<?php echo $GLOBALS['lang_start_slide'];?>';
   var langStopSlide = '<?php echo $GLOBALS['lang_stop_slide']; ?>';
   //array for image descriptions
   var picInfoName = new Array(nbPictures);
   var picInfoDesc = new Array(nbPictures);
 
   //global variables for identifying the document elements
	 var diapElt = null;
   var positionElt = null;
   var linksElt = null;
   var descriptionElt = null;
   var linkslideElt = null;
   var pictureElt = null;
	 var picture0Elt = null;
	 var picture1Elt = null;

   /* these variables enable to manage the fading effect between the background and foreground block, we use global variables*/
   var newImageElt = null;
   var oldImageElt = null;
	 
	 /* icons for toggling slides*/
	 var iconStopSlide = '<?php echo "<img src= \"" . INSTALLDIR . "/themes/" . $GLOBALS['theme'] . "/icons/pause.jpg\" alt=\"||\" title=\"{$GLOBALS['lang_stop_slide']}\" />"; ?>';
	 var iconStartSlide = '<?php echo "<img src= \"" . INSTALLDIR . "/themes/" . $GLOBALS['theme'] . "/icons/play.jpg\" alt=\">\" title=\"{$GLOBALS['lang_start_slide']}\" />"; ?>';

   //load the image arrays  from the album state
   <?php
  for ($i = 0; ($i != $nb_pictures); $i++) {
      echo "picInfoName[{$i}] = '{$pic_info[$i][0]}';\n";
      /* don't allow for quotes in the text, put a slash*/
      echo "picInfoDesc[{$i}] = '" . addslashes("{$pic_info[$i][1]}") . "';\n";
  }
?>

   function setNextPrev(i) {
       //These are global variables: pictures are on a ring
       nextPicture = (i + 1) % nbPictures;
       prevPicture = (i + nbPictures - 1) % nbPictures;//handles negative numbers as well!
      }

   function getIds() {
       //these are global variables
			  diapElt = getObj("PJGalleryDiapTrue");
        positionElt = getObj("position");
        linksElt = getObj("links");
        descriptionElt = getObj("description");
        pictureElt = getObj("picture");
        oldImageElt = getObj("image0");
        newImageElt = getObj("image1");
        linkslideElt = getObj("linkslide");
				picture0Elt = getObj("picture0");
				picture1Elt = getObj("picture1");
      }			
				

   function stripSuffix(baseName) {
       var p;

       if ((p = baseName.indexOf('.')) != -1)
        return baseName.substring(0, p);
       else
        return baseName;
      }

   /* management of image fading effects*/
   function fade ( step, beginOp, endOp, pauseStepMs) {
       //fade the opacity of the image id from begin to end by step

       var opacityIn = beginOp;
       var opacityOut = endOp;
       var pauseGlobal = 0;

       //step has to be  a divisor of endOp
       while ((100 % step) != 0) step += 1;

       do {
        opacityIn += step;
        opacityOut -= step;
        /* opacityIn and OpacityOut are not global variables and therefore their values have to be converted to string here since the scope chain is lost when the timeout code is executed*/
        setTimeout("setOpacity(" + opacityIn + ", newImageElt ); setOpacity(" + opacityOut + ", oldImageElt)", pauseGlobal);
        pauseGlobal += pauseStepMs;
       } while (opacityIn != endOp);
       setTimeout("fadingOver()", pauseGlobal - pauseStepMs);
      }

   function setOpacity (opacity, elt) {
       var eltStyle = elt.style;

       eltStyle.opacity = (opacity / 100);
       eltStyle.KhtmlOpacity = (opacity / 100);
       eltStyle.filter = "alpha(opacity=" + opacity + ")";
      }

   function viewComments() {
       pictureElt.style.height = newImageElt.height + "px";
       descriptionElt.style.display = "block";
       descriptionElt.innerHTML = picInfoDesc[self.currentPicture];
      }

   function onFaultyImage(direction) {
       /*if error in loading : skip to next picture*/
       if (slide)
        viewPicture(nextPicture, 1, true);
       else if (direction && direction == -1)
        viewPicture(prevPicture, -1);
       else
        viewPicture(nextPicture);
      }
			
   function onLoadImage() {
       /* The image has been loaded and the onload event has been fired*/
			 var position = (currentPicture + 1) + ' ' + langOf + ' ' + nbPictures;
       positionElt.innerHTML = position;

       descriptionElt.style.display = "none";
       setTimerSlide();
       //these are the values for fading read from the configuration file
			 oldImageElt.style.display = "block";
			 newImageElt.style.display = "block"
			 
       fade(step, 0, 100, pause);
       //prefetch next image: could be done whenFadingOver  to let the browser quiet while fading?
			 if (picInfoName[nextPicture].charAt(0) != '/')
				 (new Image()).src =  dirAlbumImages + picInfoName[nextPicture];
			 else
			 		(new Image()).src =   picInfoName[nextPicture];
      }

   function fadingOver() {
       /* fading is over */
			 oldImageElt.style.display = "none"; /*more secure: if fading ever fails*/
			 picture0Elt.style.display = "block";/*initially for the first image, it was set to none to avoid the unstable display of the first image*/
			 picture1Elt.style.display = "block";
       setTimeout("viewComments()", 0);
      }

   function changeDelay() {
       /*Change the pause between two running slides */
       var newDelay;

       newDelay = document.timing.inputdelay.value;
       newDelay = parseInt(newDelay);  //convert to an integer number

       if ((isNaN(newDelay)) || (newDelay < 1) || (newDelay > 30))
        ;                              // ignore the input value
       else
        delay = newDelay;
       return false;
      }

   function startSlide() {
		 /*slide show might be triggered as a result of clicking the slide show button or submtting the change pause form: make sure there's only one slide show operating at a time*/
		 if (!slide){
       linkslideElt.innerHTML = iconStopSlide;
			 startPicture = nextPicture;
			 round = -1;
			 slide = true;
       viewPicture(nextPicture, 1, true);
      }
	 }
   function stopSlide() {
       slide = false;
       clearTimeout(timer);
       linkslideElt.innerHTML = iconStartSlide;
   }

   function toggleSlide() {
       if (slide)
        stopSlide();
       else
        startSlide();
      }

   function setTimerSlide() {
       //called once the picture is loaded
       if (slide)
        /* nexPicture is a property of the global window object and therefore can be passed as a parameter*/
        timer = setTimeout("viewPicture(nextPicture, 1, true)", delay * 1000);
      }

   function viewPicture(i,/*optional parameters*/ direction, calledInSlideShow) {
       //i: picture index
       //if direction ==-1, go backwards.
   try{
       //do not manipulate document before it is loaded
       if (!self.loaded){
        return;
			 }

			 /* one round in slideshow only*/
			 if (calledInSlideShow && startPicture == i){
				 	round += 1;
			 }
			 if (calledInSlideShow && round == 1){
					stopSlide();
					return;
			 }
       // if slide show is on and the function is called outside the show to enlarge a thumbnail: stop the slide show
       if (!calledInSlideShow && slide){
        stopSlide();
       }
			 
			 setNextPrev(i);
			 currentPicture = i;
			 /*load picture i*/
       var temp = null;
       // alternate the blocks
       temp = oldImageElt;
       oldImageElt = newImageElt;
       newImageElt = temp;
       //special treatment  for  opera since it doesn't do fire onload when the image has been prefetched!

       if (window.opera) {
        newImageElt.onload = null;
        newImageElt.onerror = null;
       } else {
        newImageElt.onerror = function() {
         if (direction)
          onFaultyImage(direction);
         else
          onFaultyImage();
        };
        newImageElt.onload = onLoadImage;
       }
       //start loading the image
			 newImageElt.style.display = "none";
			 if (picInfoName[i].charAt(0) != '/')
				 newImageElt.src =  dirAlbumImages + picInfoName[i];
			 else
			 	 newImageElt.src =   picInfoName[i];
       //fire onload event manually for opera!
       if (window.opera)
        if (newImageElt.complete) {
         onLoadImage();
        } else {
         /*let's hope the complete property is not set just while here, because we are done!*/
         newImageElt.onload = onLoadImage;
         newImageElt.onerror = function() {
          if (direction)
           onFaultyImage(direction);
          else
           onFaultyImage();
         };
        }
		}//try block
		catch(ex){return;}
  }  //viewPicture()
			
   function diapLoaded() {
		 //onload handler for viewDiaporama
		 	 self.loaded = true;
			 
       if (self.top != self) {
				/* I'm a prefetch frame, just load the first picture in cache and don't start slide show*/
					if (picInfoName[0].charAt(0) != '/')
						(new Image()).src =  dirAlbumImages + picInfoName[0];
					else
			 			(new Image()).src =   picInfoName[0];
			 } else{/*
       The handler of the onload event for this document. 
			 */
			 prevPicture = 0;
			 nextPicture = 0;
			 currentPicture = -1;
       getIds();
			 diapElt.style.display = "block"; //avoid the unstability on the screen when loading
			 slide = false;
       startSlide();
      }
	 }		
	 addOnLoadHandler(diapLoaded);

//]]
</script>
</head>
<body id="PJGalleryDiap">
<?php echo "<noscript><div  class=\"error noprint\"><br />{$GLOBALS['err_javascriptenabled']} <a id=\"closewindow\"  href=\"{$view_album}?alb={$GLOBALS['root_album_desc']}\"> {$GLOBALS['lang_return_title']}</a></div></noscript>" ?>
   
   <div id="PJGalleryDiapTrue" style="display:none">

   <!-- the body is dynamically generated through innerHTML commands -->
   <div id = "position" class="noprint">
	 &nbsp;
   </div>

   <ul id = "links"  class="noprint">
	        <!--display the button links that appear at the top of the window-->
       <li><a  href="#" onclick ="javascript: viewPicture(prevPicture, -1); return false;"> <?php echo "<img src= \"" . INSTALLDIR . "/themes/" . $GLOBALS['theme'] . "/icons/childprev.jpg\" title=\"{$GLOBALS['lang_back_title']}\" alt=\"<<\" />"; ?>
			 </a></li>
			 

       <li><a  href="#" id="linkslide" onclick ="javascript: toggleSlide(); return false;"><?php echo "<img src= \"" . INSTALLDIR . "/themes/" . $GLOBALS['theme'] . "/icons/pause.jpg\" title=\"{$GLOBALS['lang_start_slide']}\" alt=\">\" />"; ?> </a></li>
			 
			 <li><form name="timing" action="" onsubmit="javascript: changeDelay(); startSlide(); return false;"><div> <input name= "inputdelay"  id="inputdelay" maxlength="10" onchange="javascript: changeDelay();" value = "<?php echo "{$delay} {$lang_timing}"  ?>" type ="text" title="<?php echo "{$lang_change_pause}"?>" /></div></form></li>
				
       <li><a id="closewindow"  href="<?php echo  "{$view_album}?alb={$GLOBALS['root_album_desc']}\"  " ?> ><?php echo "<img src= \"" . INSTALLDIR . "/themes/" . $GLOBALS['theme'] . "/icons/exit.jpg\" alt=\"{$GLOBALS['lang_return_title']}\" title=\"{$GLOBALS['lang_return_title']}\" />"; ?></a></li>
			 
			 	<li><a  href="#" onclick ="javascript: viewPicture(nextPicture); return false;"><?php echo "<img src= \"" . INSTALLDIR . "/themes/" . $GLOBALS['theme'] . "/icons/childnext.jpg\" alt=\">>\" title=\"{$GLOBALS['lang_next_title']}\" />"; ?> </a></li>

   </ul>
   <div id = "picture">
    <!-- here we use two blocks postioned in absolute to enable the fading out of the previous image and the fading in of the newly loaded image -->
     <div id ="picture0"><img id = "image0"  class= "image01" src= "" alt=""  title = "" /></div>
     <div id="picture1"><img id = "image1"  class= "image01" src= "" alt="" title = "" /></div>
    </div>
   </div>

   <div id = "description" class="noprint">
   </div>
   </div>
</body>
</html>


