<?php
/*This software is governed by a creative commons license whose terms of use are explained in the readme file */
// set the constant INSTALLDIR to the root-based directory name where pjgallery is installed. If you want these individual pages to be indexed by search engines (one page per picture) set the robots metatag to index in the album description file.*/
define ('INSTALLDIR', '/pjgallery');

/* set $view_album to the root based path of the viewAlbum.php page */
$view_album = "viewAlbum.php";

$call_FILE = __FILE__;
include_once($_SERVER['DOCUMENT_ROOT']. INSTALLDIR . "/common.inc.php");

/*check picture parameter*/
$pict_offset = (isset($_GET['picture']))? (int) $_GET['picture'] : 0;
if ($pict_offset < 0 || $pict_offset >= $nb_pictures)
	$pict_offset = 0;
$pict_previous = ($pict_offset -1 + $nb_pictures) % $nb_pictures;/*handles negative numbers as well*/
$pict_next = ($pict_offset + 1) % $nb_pictures;
$offset_thumb = ((int)($pict_offset / $GLOBALS['max_thumbnails_page']) * $GLOBALS['max_thumbnails_page']); // to enable the return to the thumbnail page
?>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="<?php echo $lang;?>" lang="<?php echo $lang; ?>">

<head>
<meta http-equiv="content-type" content="text/html; charset=<?php echo $charset ?>" />
<meta name="viewport" content="width=device-width, initial-scale=1">
<title><?php echo $lang_title_album . ": " . strip_suffix(basename($pic_info[$pict_offset][0]));?></title>
<meta name = "robots" content = "<?php echo $GLOBALS['index_pictures']; ?>" />
<meta name="description" content="<?php echo strip_suffix(basename($pic_info[$pict_offset][0])) . ' - '. $pic_info[$pict_offset][1]?>" />
<meta http-equiv ="content-script-type" content = "text/javascript" />
<link href= "<?php echo $root_css; ?>" rel= "stylesheet" type="text/css" media ="all" />
<link href= "<?php echo $root_css_print; ?>" rel= "stylesheet" type="text/css" media ="print" />
</head>
<body id="PJGalleryPict">
<div id="position" class="noprint">
<?php echo ($pict_offset +1) % ($nb_pictures + 1);
			echo  " {$GLOBALS['lang_of']} ";
			echo  $nb_pictures; 
?>
</div>
<div id="links" class="noprint">
			<?php echo "<a href=   \"viewPicture.php?alb={$GLOBALS['root_album_desc']}&amp;picture={$pict_previous}\">  
		 <img src= \"" . INSTALLDIR . "/themes/" . $GLOBALS['theme'] . "/icons/childprev.jpg\"alt= \"<<\" title=\"{$GLOBALS['lang_back_title']}\" /></a>"; ?>
		 <?php 
		 if ($offset_thumb == 0) 
			 /* optimizes without offset to return to the already loaded page in the browser cache*/
			 echo "<a href=   \"{$view_album}?alb={$GLOBALS['root_album_desc']}\">  
		 <img src= \"" . INSTALLDIR . "/themes/" . $GLOBALS['theme'] . "/icons/exit.jpg\" alt= \"{$GLOBALS['lang_return_title']}\" title=\"{$GLOBALS['lang_return_title']}\" /></a>"; 
	 	 else 
		 	echo "<a href=   \"{$view_album}?alb={$GLOBALS['root_album_desc']}&amp;offset={$offset_thumb}\">  
		 <img src= \"" . INSTALLDIR . "/themes/" . $GLOBALS['theme'] . "/icons/exit.jpg\" alt= \"{$GLOBALS['lang_return_title']}\" title=\"{$GLOBALS['lang_return_title']}\" /></a>"; 
	 ?>
		 	<?php echo "<a href=   \"viewPicture.php?alb={$GLOBALS['root_album_desc']}&amp;picture={$pict_next}\">  
		 <img src= \"" . INSTALLDIR . "/themes/" . $GLOBALS['theme'] . "/icons/childnext.jpg\" alt= \">>\" title=\"{$GLOBALS['lang_next_title']}\" /></a>"; ?>
</div>
	<?php 
	if ($pic_info[$pict_offset][0][0] ==='/') 
			$root_img_name = $pic_info[$pict_offset][0];
	else
			$root_img_name = $GLOBALS['root_album_dir']. "/images/" . $pic_info[$pict_offset][0];
	?>
<img id="picture" src="<?php echo $root_img_name ?>" alt="<?php echo $root_img_name ?>" />
<div id ="description" class="noprint">
	<?php echo $pic_info[$pict_offset][1] ?>
</div>
<!--prefetch next picture -->
	<?php 
	if ($pic_info[$pict_offset][0][0] ==='/') 
			$next_root_img_name = $pic_info[$pict_next][0];
	else
			$next_root_img_name = $GLOBALS['root_album_dir']. "/images/" . $pic_info[$pict_next][0];
	?>
<script>
(new Image()).src = "<?php echo $next_root_img_name ?>";
</script>
</body>
</html>


